#include "stdafx.h"
#include "djtsatlib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString ISatellites::GetVersionString()
{
	CString result;
	InvokeHelper(0x1, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, NULL);
	return result;
}

CString ISatellites::GetKeplerPath()
{
	CString result;
	InvokeHelper(0x2, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, NULL);
	return result;
}

void ISatellites::SetKeplerPath(LPCTSTR lpszNewValue)
{
	static BYTE parms[] = VTS_BSTR;
	InvokeHelper(0x2, DISPATCH_PROPERTYPUT, VT_EMPTY, NULL, parms, lpszNewValue);
}

long ISatellites::GetSatCount()
{
	long result;
	InvokeHelper(0x3, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, NULL);
	return result;
}

CString ISatellites::GetSatNames()
{
	CString result;
	InvokeHelper(0x4, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, NULL);
	return result;
}

double ISatellites::GetObsLat()
{
	double result;
	InvokeHelper(0x5, DISPATCH_PROPERTYGET, VT_R8, (void*)&result, NULL);
	return result;
}

void ISatellites::SetObsLat(double newValue)
{
	static BYTE parms[] = VTS_R8;
	InvokeHelper(0x5, DISPATCH_PROPERTYPUT, VT_EMPTY, NULL, parms, newValue);
}

double ISatellites::GetObsLon()
{
	double result;
	InvokeHelper(0x6, DISPATCH_PROPERTYGET, VT_R8, (void*)&result, NULL);
	return result;
}

void ISatellites::SetObsLon(double newValue)
{
	static BYTE parms[] = VTS_R8;
	InvokeHelper(0x6, DISPATCH_PROPERTYPUT, VT_EMPTY, NULL, parms, newValue);
}

double ISatellites::GetObsHeight()
{
	double result;
	InvokeHelper(0x7, DISPATCH_PROPERTYGET, VT_R8, (void*)&result, NULL);
	return result;
}

void ISatellites::SetObsHeight(double newValue)
{
	static BYTE parms[] = VTS_R8;
	InvokeHelper(0x7, DISPATCH_PROPERTYPUT, VT_EMPTY, NULL, parms, newValue);
}

CString ISatellites::PassListForPeriod(LPCTSTR Name, double UTCdate, long MinSeconds, long NumDays, double MinElevDegrees)
{
	CString result;
	static BYTE parms[] = VTS_BSTR VTS_R8 VTS_I4 VTS_I4 VTS_R8;
	InvokeHelper(0x8, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, Name, UTCdate, MinSeconds, NumDays, MinElevDegrees);
	return result;
}

BOOL ISatellites::IsVisible(LPCTSTR Name, double JulianTime, double ThresholdDeg, BOOL* Southbound, double* Azumuth, double* Elevation, double* Longitude, double* Latitude, double* Range, double* RangeRate, double* Altitude, double* Phase)
{
	BOOL result;
	static BYTE parms[] = VTS_BSTR VTS_R8 VTS_R8 VTS_PBOOL VTS_PR8 VTS_PR8 VTS_PR8 VTS_PR8 VTS_PR8 VTS_PR8 VTS_PR8 VTS_PR8;
	InvokeHelper(0x9, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, Name, JulianTime, ThresholdDeg, Southbound, Azumuth, Elevation, Longitude, Latitude, Range, RangeRate, Altitude, Phase);
	return result;
}

double ISatellites::DateTimeToJT(double DateTime)
{
	double result;
	static BYTE parms[] = VTS_R8;
	InvokeHelper(0xa, DISPATCH_METHOD, VT_R8, (void*)&result, parms, DateTime);
	return result;
}

int ISatellites::GetRevNumber()
{
	int result;
	InvokeHelper(11, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, NULL);
	return result;
}

double ISatellites::GetOrbitPhase()
{
	double result;
	InvokeHelper(12, DISPATCH_PROPERTYGET, VT_R8, (void*)&result, NULL);
	return result;
}

double ISatellites::FindAOS(CString Name, double PredictTime)
{
	double result;
	static BYTE parms[] = VTS_BSTR VTS_R8;
	InvokeHelper(13, DISPATCH_METHOD, VT_R8, (void*)&result, parms, Name, PredictTime);
	return result;
}

double ISatellites::FindLOS(CString Name, double PredictTime)
{
	double result;
	static BYTE parms[] = VTS_BSTR VTS_R8;
	InvokeHelper(14, DISPATCH_METHOD, VT_R8, (void*)&result, parms, Name, PredictTime);
	return result;
}

double ISatellites::GetMeanAnomaly()
{
	double result;
	InvokeHelper(15, DISPATCH_PROPERTYGET, VT_R8, (void*)&result, NULL);
	return result;
}

void ISatellites::SatState(double* X, double* Y, double* Z, double* Xdot, double* Ydot, double* Zdot)
{
	static BYTE parms[] = VTS_PR8 VTS_PR8 VTS_PR8 VTS_PR8 VTS_PR8 VTS_PR8;
	InvokeHelper(16, DISPATCH_METHOD, VT_EMPTY, NULL, parms, X, Y, Z, Xdot, Ydot, Zdot);
}

double ISatellites::Period(CString Name)
{
	double result;
	static BYTE parms[] = VTS_BSTR;
	InvokeHelper(17, DISPATCH_METHOD, VT_R8, (void*)&result, parms, Name);
	return result;
}

void ISatellites::KeplerData(LPCTSTR Name,double* JulianEpoch, double* Inclination, double* RAAN,
	double* Eccentricity, double* ArgOfPerigee, double* DecayRate, double* Period, double* MeanAnomaly)
{
	static BYTE parms[] = VTS_BSTR VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_R8;
	InvokeHelper(18, DISPATCH_METHOD, VT_EMPTY, NULL, parms, Name, JulianEpoch, Inclination, RAAN, Eccentricity, ArgOfPerigee, DecayRate, Period, MeanAnomaly);
}

CString ISatellites::MakePassDetails(CString PassDescription, int StepSeconds)
{
	CString result;
	static BYTE parms[] = VTS_BSTR VTS_I4;
	InvokeHelper(19, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, PassDescription, StepSeconds);
	return result;
}
